// Verilog test fixture created from schematic /home/steev/Xilinx/speccy_pl_1/ti_of_ttl.sch - Tue Mar 28 14:13:29 2017

`timescale 1ns / 1ps
`define auto_init = 1

module ti_of_ttl_ti_of_ttl_sch_tb();

// Inputs
   reg IORQn;
   reg WRn;
   reg RDn;
   reg [7:0] portIN;
   reg MREQn;
   reg M1n;
   reg [15:0] busA;

// Output
   wire [7:0] portOUT;
   wand ROMCSn;
   wand RAMn;
   wand ROMn;
	
	wire [7:0] busD;

// Instantiate the UUT
   ti_of_ttl_v1b UUT (
		.IORQn(IORQn), 
		.WRn(WRn), 
		.RDn(RDn), 
		.busD(busD), 
		.portIN(portIN), 
		.portOUT(portOUT), 
		.MREQn(MREQn), 
		.M1n(M1n), 
		.busA(busA), 
		.ROMCSn(ROMCSn), 
		.RAMn(RAMn), 
		.ROMn(ROMn)
   );
	
	// Bidirs
	assign busD = busD_q;
	reg [7:0] busD_q;

assign		ROMn =1;
assign		RAMn =1;
assign		ROMCSn=1;
	
// Initialize Inputs
initial begin
		IORQn = 1;
		WRn = 1;
		RDn = 1;
		busD_q = 8'hzz;
		portIN = 8'hff;
		MREQn = 1;
		M1n = 1;
		busA = 16'hffff;
end

	task io_write(input [15:0] addr, input [7:0] val);
	begin
		busA <= addr;
		busD_q <= val;
		#5 IORQn <= 0;
			WRn <= 0;
		#25 IORQn <= 1;
			WRn <= 1;
		#5	busD_q <= 8'hzz;
		#5;
	end
	endtask
	
	task io_read(input [15:0] addr, input [7:0] val);
	begin
		busA <= addr;
		portIN<=val;
		busD_q <= 8'hzz;
		#5 IORQn <= 0;
			RDn <= 0;
		#25 IORQn <= 1;
			RDn <= 1;
		#5 portIN<=8'hff;
		#5;
	end
	endtask

	task mem_read(input [15:0] addr);
	begin
		busA <= addr;
		#5 MREQn <= 0;
			RDn <= 0;
		#25 MREQn <= 1;
			RDn <= 1;
		#5;
	end
	endtask
	
	task exec (input [15:0] addr);
	begin
		busA<=addr;
		M1n <=0;
		#5 RDn<=0;
			MREQn<=0;
		#25 RDn<=1;
			MREQn<=1;
			M1n<=1;
		#5;
	end
	endtask

	reg [7:0] pval = 8'h5a;
	always begin
		#10 io_write(16'h20, 8'h10);
		#10 io_write(16'hef, pval);
		#10 io_write(16'hfe, 8'hcc);
		#10 io_read(16'hc6, ~pval);
		#10 io_read(16'hef, ~pval+3);
		#10 exec(16'hffff);
		#10 exec(16'h0000);
		#10 exec(16'h0001);
		#10 mem_read(16'h1fff);
		#10 mem_read(16'h2000);
		#10 mem_read(16'h3000);
		#10 mem_read(16'h4000);
		#10 exec(16'h0604);
		#10 exec(16'h0605);
		#10 exec(16'h0007);
		#10 exec(16'h0008);
		#10 exec(16'h0009);
		#10 exec(16'h000a);
		#10 mem_read(16'h1fff);
		#10 mem_read(16'h2000);
		#10 mem_read(16'h3000);
		#10 mem_read(16'h4000);
		#10 exec(16'h0604);
		#10 exec(16'h0605);
	
		pval <= pval + 1'b1;
	end
endmodule



